//------------------------------------------------------------------------------
// Copyright (c) 2010
// Robert Johansson
// Raditex AB.
// All rights reserved.
//------------------------------------------------------------------------------

#ifndef _IPIO_MODBUS_H_
#define _IPIO_MODBUS_H_

#include <stdlib.h>
#include <sys/types.h>

extern char ipio_modbus_error_str[256];

typedef struct _ipio_status {
    
    int relay0, relay1, relay2, relay3;
    int di0, di1, di2, di3;
    int do0, do1, do2, do3;
    int dac0, dac1, dac2, dac3;
    int adc0, adc1, adc2, adc3;

    int temperature;
    int counter;

    int version;

} ipio_status_t;

int ipio_relay_read(char *host, int addr);
int ipio_relay_write(char *host, int addr, int value);

int ipio_digital_output_read(char *host, int addr);
int ipio_digital_output_write(char *host, int addr, int value);

int ipio_digital_input_read(char *host, int addr);

int ipio_dac_read(char *host, int addr);
int ipio_dac_write(char *host, int addr, int value);

int ipio_adc_read(char *host, int addr);

int ipio_counter_read(char *host);

int ipio_version(char *host);

double ipio_temperature_read(char *host);

#endif /* _IPIO_MODBUS_H_ */

